# class IO::Stapled

- IO::Stapled
- IO
- Reference
- Object

##
Overview

This class staples together two unidirectional `IO`s to form a single, bidirectional `IO`.

Example (loopback):

    io = IO::Stapled.new(*IO.pipe)
    io.puts "linus"
    io.gets # => "linus"

Most methods simply delegate to the underlying `IO`s.

##
Defined in:

io/stapled.cr

##
Constructors

- .new(reader : IO, writer : IO, sync_close : Bool = false)

  Creates a new `IO::Stapled` which reads from reader and writes to writer.

##
Class Method Summary

- .pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil, &)

  Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.

- .pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(self, self)

  Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a `Tuple`.

##
Instance Method Summary

- #close : Nil

  Closes this `IO`.

- #closed? : Bool

  Returns `true` if this `IO` is closed.

- #flush : self

  Flushes `writer`.

- #gets(delimiter : Char, limit : Int, chomp = false) : String | Nil

  Gets a string from `reader`.

- #peek : Bytes | Nil

  Peeks into `reader`.

- #read(slice : Bytes) : Int32

  Reads a slice from `reader`.

- #read_byte : UInt8 | Nil

  Reads a single byte from `reader`.

- #skip(bytes_count : Int) : Nil

  Skips `reader`.

- #skip_to_end : Nil

  Skips `reader`.

- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

- #write(slice : Bytes) : Nil

  Writes a slice to `writer`.

- #write_byte(byte : UInt8) : Nil

  Writes a byte to `writer`.

### Instance methods inherited from class `IO`

<<(obj : _) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(chomp : Bool = true) : String | Nil
gets(limit : Int, chomp : Bool = false) : String | Nil
gets(delimiter : Char, chomp : Bool = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string : String, args : Array | Tuple) : Nil
printf(format_string : String, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) : Int32 read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object : _, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src : IO, dst : IO, limit : Int) : Int64
copy(src : IO, dst : IO) : Int64 copy, pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = nil, write_blocking = nil, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(reader : IO, writer : IO, sync_close : Bool = false) #

Creates a new `IO::Stapled` which reads from reader and writes to writer.

##
Class Method Detail

def self.pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil, &) #

Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.

Both endpoints and the underlying `IO`s are closed after the block (even if `#sync_close?` is `false`).

def self.pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(self, self) #

Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a `Tuple`.

##
Instance Method Detail

def close : Nil #

Closes this `IO`.

If `#sync_close?` is `true`, it will also close the underlying `IO`s.

def closed? : Bool #

Returns `true` if this `IO` is closed.

Underlying `IO`s might have a different status.

def flush : self #

Flushes `writer`.

def gets(delimiter : Char, limit : Int, chomp = false) : String | Nil #

Gets a string from `reader`.

def peek : Bytes | Nil #

Peeks into `reader`.

def read(slice : Bytes) : Int32 #

Reads a slice from `reader`.

def read_byte : UInt8 | Nil #

Reads a single byte from `reader`.

def skip(bytes_count : Int) : Nil #

Skips `reader`.

def skip_to_end : Nil #

Skips `reader`.

def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.

def write(slice : Bytes) : Nil #

Writes a slice to `writer`.

def write_byte(byte : UInt8) : Nil #

Writes a byte to `writer`.